package name.panitz.crempel.tool.classInfo;

import java.lang.reflect.Method;
import name.panitz.domtest.DomTreeNode;
import javax.swing.*;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;

public class ClassAsXML {
  static Document convert(Class klasse) 
                    throws ParserConfigurationException{
    Document doc
      = DocumentBuilderFactory
	.newInstance()
	.newDocumentBuilder()
	.newDocument() ;

    Element classEl 
     =doc.createElement(klasse.isInterface()?"interface":"class");
    doc.appendChild(classEl);

    Element nameEl =doc.createElement("name");
    nameEl.appendChild(doc.createTextNode(klasse.getName()));
    classEl.appendChild(nameEl);

    for (Method m:klasse.getMethods()){
      final Element methodEl=getMethodInformation(doc,m);
      classEl.appendChild(methodEl);
    }
    return doc;
  }

  static Element getMethodInformation(Document doc,Method m){
    final Element methodEl=doc.createElement("method");
    final Element nameEl =doc.createElement("name");
    nameEl.appendChild(doc.createTextNode(m.getName()));
    methodEl.appendChild(nameEl);
    for (Class param:m.getParameterTypes()){
     final Element paramEl=doc.createElement("parameter");
     paramEl.appendChild(doc.createTextNode(param.getName()));
     methodEl.appendChild(paramEl);
    }
    final Element resultEl=doc.createElement("result");
    resultEl.appendChild
     (doc.createTextNode(m.getReturnType().getName()));
    methodEl.appendChild(resultEl);
    return methodEl;
  }

  public static void main(String [] args) throws Exception{
    JFrame f = new JFrame(args[0]);
    f.getContentPane()
     .add(new JTree(new DomTreeNode
                      (convert(Class.forName(args[0])))));
    f.pack();
    f.setVisible(true);
  }
}