package name.panitz.domtest;

import name.panitz.crempel.util.FromTo;
import java.util.Enumeration;
import java.util.Iterator;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import org.w3c.dom.CharacterData;
import javax.swing.tree.*;
import javax.swing.*;

public class DomTreeNode implements TreeNode{
  Node node;
  public DomTreeNode(Node n){node=n;}

  public TreeNode getChildAt(int childIndex){
    return new DomTreeNode(node.getChildNodes().item(childIndex));
  }

  public int getChildCount(){
    return node.getChildNodes().getLength();}
  public boolean isLeaf(){
    return node.getChildNodes().getLength()==0;} 
  public TreeNode getParent(){
    return new DomTreeNode(node.getParentNode());}
  public boolean getAllowsChildren(){
    return (node instanceof Element);}
  public int getIndex(TreeNode n){
    final NodeList children = node.getChildNodes();
    for (Integer index : new FromTo(0,children.getLength()-1)){
      if (children.item(index).equals(n)) return index;
    }
    return -1;
  }  
  public Enumeration<DomTreeNode> children(){
    return new Enumeration<DomTreeNode>(){
      final Iterator<Node> it
         = new NoteListIterator(node.getChildNodes());
      public boolean hasMoreElements(){return it.hasNext();}
      public DomTreeNode nextElement() {return new DomTreeNode(it.next());}
    };
  }

  public String toString(){
    if (node instanceof CharacterData) return node.getNodeValue();
    return node.getNodeName();}

  public static void main(String [] args){
    JFrame f = new JFrame(args[0]);
    f.getContentPane()
     .add(
       new JTree(new DomTreeNode(ParseXML.parseXml(args[0]))));
    f.pack();
    f.setVisible(true);
  }
}