package name.panitz.webexample.address;
import java.io.*;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import java.util.*;
import javax.xml.parsers.*;

import name.panitz.crempel.util.xml.*;

public class AdressFile extends AbstractAdressverwaltung{
  static Map<File,AdressFile> instances
   = new HashMap<File,AdressFile>();

  File source;
  Addresses addresses = null;

  public static AdressFile getInstance(String source) 
                                        throws Exception{
    File dataFile = new File(source);
    AdressFile instance = instances.get(dataFile);
   
    if (instance == null){ 
      instance = new AdressFile(dataFile);
      instances.put(dataFile,instance);
    }
    return instance;
  }

  private AdressFile(File source) throws Exception{
    this.source=source;

    Document doc =
      DocumentBuilderFactory
       .newInstance()
       .newDocumentBuilder()
       .parse(source);
    final List<Node> ns = new ArrayList<Node>();
    ns.add(doc.getDocumentElement()); 
    addresses = new AddressesParser().parse(ns).e1;
  }

  synchronized public Addresses getAddresses( ){return addresses;}
  synchronized public void save()throws Exception{
    FileWriter write = new FileWriter(source);
    writeAddresses(write);
    write.close();
  }
}