package name.panitz.webexample.address;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;

import javax.servlet.ServletException;
import javax.servlet.http.*;

import java.io.File;

public final class ListAddresses extends HttpServlet {
  public void doGet(HttpServletRequest request
                    ,HttpServletResponse response)
        throws IOException, ServletException {
    response.setContentType("text/html");
    PrintWriter writer = response.getWriter();

    writer.println("<html>");
    writer.println("<head>");
    writer.println("<title>Gespeicherte Adressen</title>");
    writer.println("</head>");
    writer.println("<body bgcolor=\"white\">");
	
    try{
      Adressverwaltung adv 
         = AdressverwaltungFactory
              .getAdressverwaltung(getServletConfig()
                                   .getServletContext()
                                   .getRealPath(".")
                                   +"/addresses.xml");

      writeAddressesAsHTML(adv.getAddresses(),writer);
    }catch(Exception e){writer.println(e);}
    writer.println("</body>");
    writer.println("</html>");
  }

  public static void writeAddressesAsHTML
                   (Addresses adrs,Writer w) throws IOException{
    w.write("\n<table>");
    w.write("\n<tr><th>Name</th><th>email</th></tr>");
    for (Address address:adrs.getXs()){
      w.write("\n <tr><td>");
      w.write(address.getTheFullname().getPcdata());
      w.write("</td><td>");
      w.write(address.getTheEmail().getPcdata());
      w.write("</td></tr>");
    }
    w.write("\n</table>");
  }
}