package name.panitz.xml;
import java.util.List;

public class Show extends XMLVisitor<StringBuffer> {
  StringBuffer result = new StringBuffer();

  public StringBuffer eval(Element element){
    result.append("<");
    result.append(element.getName().toString());
    for (Attribute attr:(List<Attribute>)element.getAttributes())
      result.append("\u0020"+attr);
    if (element.getChildren().isEmpty())result.append("/>");
    else {
      result.append(">");
      for (XML xml:(List<XML>)element.getChildren()) 
        xml.visit(this);
      result.append("</");
      result.append(element.getName().toString());
      result.append(">");}
    return result; }      
  public StringBuffer eval(Comment comment){
    result.append("<!--"+comment.getComment()+"-->");
    return result;}
  public StringBuffer eval(Text text){
    result.append(text.getText());
    return result;}
  public StringBuffer eval(CDataSection cdata){
    result.append("<![CDATA["+cdata.getCdata()+"]"+"]>");
    return result;}
  public StringBuffer eval(Entity entity){
    result.append("&"+entity.getName()+";");
    return result;} 
  public StringBuffer eval(ProcessingInstruction pi){
    result.append("<?"+pi.getTarget()+"\u0020");
    result.append(pi.getInstruction()+"?>");
    return result;}
}