package name.panitz.xml.xpath;
import name.panitz.crempel.util.FromTo;
import java.util.List;
import java.util.ArrayList;
import org.w3c.dom.*;
import name.panitz.domtest.*;

public class Axes{
  public static List<Node> nodelistToList (NodeList nl){
    List<Node> result = new ArrayList<Node>();
    for (int i:new FromTo(0,nl.getLength()-1)){
      result.add(nl.item(i));
    }
    return result;
  }  public static List<Node> self(Node n){
    List<Node> result = new ArrayList<Node>();
    result.add(n);
    return result;
  }  public static List<Node> child(Node n){
    return nodelistToList(n.getChildNodes());
  }  public static List<Node> descendant(Node n){
    List<Node> result = new ArrayList<Node>();
    for (Node child:child(n)){
      result.add(child);
      result.addAll(descendant(child));
    }
    return result;
  }  public static List<Node> descendant_or_self(Node n){
    List<Node> result = self(n);
    result.addAll(descendant(n));
    return result;
  }  public static List<Node> parent(Node n){
     List<Node> result = new ArrayList<Node>();
     result.add(n.getParentNode());
     return result;
  }  public static List<Node> ancestor(Node n){
    List<Node> result = new ArrayList<Node>();
    for (Node parent:parent(n)){
      if (parent!=null){
        result.addAll(ancestor(parent));
        result.add(parent);
      }
    }
    return result;
  }  public static List<Node> ancestor_or_self(Node n){
    List<Node> result = ancestor(n);
    result.addAll(self(n));
    return result;
  }  public static List<Node> following_sibling(Node n){
    List<Node> result = new ArrayList<Node>();
    int nodeType = n.getNodeType();
    boolean take = false;
    if (nodeType != Node.ATTRIBUTE_NODE){
      for (Node sibling:child(n.getParentNode())){
        if (take) result.add(sibling);
        if (sibling==n) take=true;
      }
    }
    return result;
  }  public static List<Node> preceding_sibling(Node n){
    List<Node> result = new ArrayList<Node>();
    int nodeType = n.getNodeType();
    if (nodeType != Node.ATTRIBUTE_NODE){
      for (Node sibling:child(n.getParentNode())){
        if (sibling==n) break;
        result.add(sibling);
      }
    }
    return result;
  }  public static List<Node> following(Node n){
    List<Node> result = new ArrayList<Node>();
    for (Node follow_sib:following_sibling(n)){
      result.add(follow_sib);
      result.addAll(descendant(follow_sib));
    }
    return result;
  }  public static List<Node> preceding(Node n){
    List<Node> result = new ArrayList<Node>();
    for (Node preced_sib:preceding_sibling(n)){
      result.add(preced_sib);
      result.addAll(descendant(preced_sib));
    }
    return result;
  }  public static List<Node> attribute(Node n){
    List<Node> result = new ArrayList<Node>();
    if (n.getNodeType()==Node.ELEMENT_NODE){
      NamedNodeMap nnm = n.getAttributes();
      for (int i:new FromTo(0,nnm.getLength()-1)){
        Node current = nnm.item(i);
        if (!current.getNodeName().startsWith("xmlns"))
          result.add(current);
      }
    }
    return result;
  }  public static List<Node> namespace(Node n){
    List<Node> result = new ArrayList<Node>();
    if (n.getNodeType()==Node.ELEMENT_NODE){
      NamedNodeMap nnm = n.getAttributes();
      for (int i:new FromTo(0,nnm.getLength()-1)){  
        Node current = nnm.item(i);
        if (current.getNodeName().startsWith("xmlns"))
          result.add(current);
      }
    }
    return result;
  }  public static List<Node> getAxis(Node n,AxisType axis){
    return ancestor(n); 
 /*   switch (axis){
      case ancestor          : return ancestor(n); 
      case ancestor_or_self  : return ancestor_or_self(n); 
      case attribute         : return attribute(n);
      case child             : return child(n); 
      case descendant        : return descendant(n); 
      case descendant_or_self: return descendant_or_self(n); 
      case following         : return following(n);
      case following_sibling : return following_sibling(n); 
      case namespace         : return namespace(n);
      case parent            : return parent(n);
      case preceding         : return preceding(n); 
      case preceding_sibling : return preceding_sibling(n);
      case self              : return self(n);
      default                :throw new UnsupportedOperationException();
    }*/
  }
}