package name.panitz.xml.xpath;

import java.util.List;
import java.util.ArrayList;
import org.w3c.dom.*;
import static org.w3c.dom.Node.*;
import name.panitz.domtest.*;

import static name.panitz.xml.xpath.Axes.*;

public class EvalXPath extends XPathVisitor<XPathResult> {
  Node current;
  int contextPosition=1;
  int contextSize=1;

  public EvalXPath(Node n){current=n;}
  public EvalXPath(Node n,int pos,int size){
    this(n);contextPosition=pos;contextSize=size;}  public XPathResult eval(Axis e){
    return new Nodes(
      DoNodeTest.evalAxisExpr(e.getType(),e.getNodeTest(),current));
  }  public XPathResult eval(RootSlash e){
    Node doc ;
    if (current.getNodeType()==DOCUMENT_NODE) doc=current;
    else{
      doc = current.getOwnerDocument();
    }
    if (doc!=null) return e.getExpr().visit(new EvalXPath(doc));

    return new Nodes(new ArrayList<Node>());
  }  public XPathResult eval(Slash e){
    XPathResult res1 = e.getE1().visit(this);

    if (res1 instanceof Nodes){
      final List<Node> resultNodes = new ArrayList<Node>();
      final List<Node> e1s = ((Nodes)res1).getValue();
      final int size = e1s.size();
      int pos = 1;
      for (Node e1:e1s){
        XPathResult e2s = e.getE2().visit(new EvalXPath(e1,pos,size));
        if (e2s instanceof Nodes)
           resultNodes.addAll(((Nodes)e2s).getValue());
        else return e2s;
        pos=pos+1;
      }
      return new Nodes(resultNodes);
    }
    return res1;
  }  public XPathResult eval(Union e){
    XPathResult r1 = e.getE1().visit(this);
    XPathResult r2 = e.getE1().visit(this);
    if (r1 instanceof Nodes && r2 instanceof Nodes){
      List<Node> resultNodes = ((Nodes)r1).getValue();
      resultNodes.addAll(((Nodes)r2).getValue());
      return new Nodes(resultNodes);
    }
    return r1;
  }  public XPathResult  eval(NumLiteral e){
    return new NumResult(e.getValue());}  public XPathResult  eval(StringLiteral e){
    return new StringResult(e.getValue());}  public XPathResult  eval(QualifiedExpr e){
    XPathResult result1 = e.getExpr().visit(this);
    if (result1 instanceof Nodes){
      final List<Node> resultNodes = new ArrayList<Node>();
      final List<Node> rs = ((Nodes)result1).getValue();
      final int size = rs.size();
      int pos = 1;
      for (Node r : rs){
        XPathResult qs 
           = e.getQualifier().visit(new EvalXPath(r,pos,size));
        if (qs.visit(new TestQualifier(r,pos,size)))
          resultNodes.add(r);
        pos=pos+1;
      }
      return new Nodes(resultNodes);
    }
    return result1;
  }  public XPathResult  eval(RootSlashSlash e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(SlashSlash e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(TagName e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(AttributeName e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(Dot e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(DotDot e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(NodeSelect e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(TextSelect e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(PISelect e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(CommentSelect e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(Star e){
   throw new UnsupportedOperationException();}
  public XPathResult  eval(AtStar e){
   throw new UnsupportedOperationException();}  public XPathResult  eval(Function e){
   throw new UnsupportedOperationException();
  }
  public XPathResult  eval(BinOperator e){
   throw new UnsupportedOperationException();
  }
  public XPathResult  eval(UnaryOperator e){
   throw new UnsupportedOperationException();
  }  public static XPathResult eval(XPath xpath,Node n){
    System.out.println(xpath.visit(new NormalizeXPath())
                            .visit(new ShowXPath()));

    System.out.println(xpath.visit(new NormalizeXPath())
                            .visit(new RemoveAbbreviation())
                            .visit(new ShowXPath()));

    return xpath.visit(new NormalizeXPath())
                .visit(new RemoveAbbreviation())
                .visit(new EvalXPath(n));
  }

  public static void main(String [] args){
    Node doc = ParseXML.parseXml(args[0]);

    XPathResult result 
     =  eval(new QualifiedExpr
           (new RootSlashSlash
               (new Slash(new TagName("code"),new AttributeName("class")))
           ,new StringLiteral("XPath"))
            ,doc);
    System.out.println(result);

    result 
     =  eval
         (new QualifiedExpr(new RootSlash
            (new Slash(new TagName("skript")
            ,new Slash(new TagName("kapitel")
            ,new Slash(new TagName("section"),new DotDot()))))
          ,new NumLiteral(1))
         ,doc);

    System.out.println(result);

    result 
     =  eval
         (new RootSlash
            (new Slash(new TagName("skript")
            ,new Slash(new TagName("kapitel")
            ,new QualifiedExpr(new TagName("section"),new NumLiteral(2)))))
         ,doc);

    System.out.println(result);
  }
}