package name.panitz.xml.xpath;

import java.util.List;
import java.util.ArrayList;
import org.w3c.dom.*;
import name.panitz.domtest.*;

public class NormalizeXPath extends XPathVisitor<XPath> {

public XPath eval(Axis e){return e;}

public XPath eval(RootSlash e){
  final XPath n1 = e.getExpr();
  return new RootSlash(e.getExpr().visit(this));}


public XPath eval(RootSlashSlash e){
  return new RootSlashSlash(e.getExpr().visit(this));}

/**  mache Slash(Slash(e1,e2),e3)
   zu Slash(e1,Slash(e2,e3))
und
  mache Slash(SlashSlash(e1,e2),e3)
   zu SlashSlash(e1,Slash(e2,e3))
*/

public XPath eval(Slash e){
  final XPath n1 = e.getE1();
  final XPath e3 = e.getE2();
  if (n1 instanceof Slash){
    final XPath e1 = ((Slash)n1).getE1();
    final XPath e2 = ((Slash)n1).getE2();
    return new Slash(e1,new Slash(e2,e3)).visit(this);    
  }
  if (n1 instanceof SlashSlash){
    final XPath e1 = ((SlashSlash)n1).getE1();
    final XPath e2 = ((SlashSlash)n1).getE2();
    return new SlashSlash(e1,new Slash(e2,e3)).visit(this);    
  }
  return new Slash(n1.visit(this),e3.visit(this));
}

public XPath eval(SlashSlash e){
  final XPath n1 = e.getE1();
  final XPath e3 = e.getE2();
  if (n1 instanceof Slash){
    final XPath e1 = ((Slash)n1).getE1();
    final XPath e2 = ((Slash)n1).getE2();
    return new Slash(e1,new SlashSlash(e2,e3)).visit(this);    
  }
  if (n1 instanceof SlashSlash){
    final XPath e1 = ((SlashSlash)n1).getE1();
    final XPath e2 = ((SlashSlash)n1).getE2();
    return new SlashSlash(e1,new SlashSlash(e2,e3)).visit(this);    
  }
  return new Slash(n1.visit(this),e3.visit(this));
}

public XPath eval(Union e){
  return new Union(e.getE1().visit(this),e.getE2().visit(this));}
public XPath eval(TagName e){return e;}
public XPath eval(AttributeName e){return e;}
public XPath eval(Dot e){return e;}
public XPath eval(DotDot e){return e;}
public XPath eval(NodeSelect e){return e;}
public XPath eval(TextSelect e){return e;}
public XPath eval(PISelect e){return e;}
public XPath eval(CommentSelect e){return e;}
public XPath eval(Star e){return e;}
public XPath eval(AtStar e){return e;}

public XPath eval(Function e){return e;}
public XPath eval(BinOperator e){return e;}
public XPath eval(UnaryOperator e){return e;}
public XPath eval(QualifiedExpr e){
  return new QualifiedExpr(e.getExpr().visit(this)
                          ,e.getQualifier().visit(this));}
public XPath eval(NumLiteral e){return e;}
public XPath eval(StringLiteral e){return e;}
}