package name.panitz.xml.xpath;

import java.util.List;
import java.util.ArrayList;
import org.w3c.dom.*;
import name.panitz.domtest.*;

public class RemoveAbbreviation extends XPathVisitor<XPath> {public XPath eval(RootSlashSlash e){
  /* //expr -> /descendant-or-self::node()/expr  */
  return 
    new RootSlash(
     new Slash(new Axis(AxisType.descendant_or_self,new IsNode())
              ,e.getExpr().visit(this)));}public XPath eval(SlashSlash e){
  final XPath e1 = e.getE1();
  final XPath e2 = e.getE2();
  /* e1//e2 -> e1/descendant-or-self::node()/e2 */
  return 
   new Slash
     (e1.visit(this)
     ,new Slash(new Axis(AxisType.descendant_or_self,new IsNode())
               ,e2.visit(this)));}public XPath eval(Dot e){
  return new Axis(AxisType.self,new IsNode());}public XPath eval(DotDot e){
  return new Axis(AxisType.parent,new IsNode());}public XPath eval(TagName e){
  return new Axis(AxisType.child,new QName("",e.getName()));}public XPath eval(AttributeName e){
  return new Axis(AxisType.attribute,new QName("",e.getName()));}public XPath eval(NodeSelect e){
  return new Axis(AxisType.child,new IsNode());}public XPath eval(TextSelect e){
  return new Axis(AxisType.child,new IsText());}public XPath eval(PISelect e){
  return new Axis(AxisType.child,new IsProcessingInstruction());}public XPath eval(CommentSelect e){
  return new Axis(AxisType.child,new IsComment());}public XPath eval(Star e){
  return new Axis(AxisType.child,new StarTest());}public XPath eval(AtStar e){
  return new Axis(AxisType.attribute,new StarTest());}public XPath eval(Slash e){
  return new Slash(e.getE1().visit(this),e.getE2().visit(this));}
public XPath eval(Axis e){return e;}
public XPath eval(RootSlash e){
  return new RootSlash(e.getExpr().visit(this));}
public XPath eval(Union e){
  return new Union(e.getE1().visit(this),e.getE2().visit(this));}
public XPath eval(Function e){
  final List<XPath> args = e.getArguments();
  List<XPath> newArgs = new ArrayList<XPath>();
  for (XPath arg:args) newArgs.add(arg.visit(this));
  return new Function(e.getName(),newArgs);}
public XPath eval(BinOperator e){
  return new BinOperator(e.getName()
                        ,e.getE1().visit(this)
                        ,e.getE2().visit(this));}
public XPath eval(UnaryOperator e){
  return new UnaryOperator(e.getName(),e.getExpr().visit(this));}
public XPath eval(QualifiedExpr e){
  return new QualifiedExpr(e.getExpr().visit(this)
                          ,e.getQualifier().visit(this));}
public XPath eval(NumLiteral e){return e;}
public XPath eval(StringLiteral e){return e;}
}