package name.panitz.xml.xpath;

public class ShowXPath extends XPathVisitor<StringBuffer> {
  StringBuffer result = new StringBuffer();
  public StringBuffer eval(Axis e){
    result.append(e.getType());
    result.append("::");
    result.append(e.getNodeTest().visit(new ShowNodeTest()));
    return result;
  }
  public StringBuffer eval(RootSlash e){
    result.append("/"); e.getExpr().visit(this);
    return result;}
  public StringBuffer eval(RootSlashSlash e){
    result.append("//"); e.getExpr().visit(this);
    return result;}
  public StringBuffer eval(Slash e){
    e.getE1().visit(this);result.append("/");e.getE2().visit(this);
    return result;}
  public StringBuffer eval(SlashSlash e){
    e.getE1().visit(this);result.append("//");e.getE2().visit(this);
    return result;}
  public StringBuffer eval(TagName e){result.append(e.getName());
    return result;}
  public StringBuffer eval(AttributeName e){
    result.append("@");result.append(e.getName());
    return result;}
  public StringBuffer eval(Dot e){result.append(".");
    return result;}
  public StringBuffer eval(DotDot e){result.append("..");
    return result;}
  public StringBuffer eval(NodeSelect e){result.append("node()");
    return result;}
  public StringBuffer eval(TextSelect e){result.append("text()");
    return result;}
  public StringBuffer eval(CommentSelect e){result.append("comment()");
    return result;}
  public StringBuffer eval(PISelect e){
    result.append("processing-instruction()");
    return result;}
  public StringBuffer eval(Star e){result.append("*");
    return result;}
  public StringBuffer eval(AtStar e){result.append("@*");
    return result;}
  public StringBuffer eval(Union e){
    e.getE1().visit(this);result.append("|");e.getE2().visit(this);
    return result;}
  public StringBuffer eval(Function e){
    result.append(e.getName());result.append("(");
    boolean first = true;
    for (XPath arg:e.getArguments()){
      if (!first) result.append(",");else first=false;
      arg.visit(this);
    }
    result.append(")");
    return result;}
  public StringBuffer eval(UnaryOperator e){
    result.append(e.getName()+"\u0020");e.getExpr().visit(this);
    return result;}
  public StringBuffer eval(BinOperator e){
    e.getE1().visit(this);result.append("\u0020"+e.getName()+"\u0020");
    e.getE2().visit(this);return result;}
  public StringBuffer eval(QualifiedExpr e){
    e.getExpr().visit(this);result.append("[");
    e.getQualifier().visit(this);result.append("]");
    return result;}
  public StringBuffer eval(NumLiteral e){result.append(""+e.getValue());
    return result;}
  public StringBuffer eval(StringLiteral e){
   result.append("\"");result.append(e.getValue()) ;result.append("\"");
   return result;}
}